Subject: Re: [RFC PATCH v3 00/10] an introduction of library operating system for Linux (LibOS)

From: Hajime Tazaki<[email-masked]>
Date: Fri, 24 Apr 2015 17:22:02 +0900

Hi Richard,

At Fri, 24 Apr 2015 09:40:32 +0200,
Richard Weinberger wrote:
> 
> Hi!
> 
> Am 19.04.2015 um 15:28 schrieb Hajime Tazaki:
> > changes from v2:
> > - Patch 02/11 ("slab: add private memory allocator header for arch/lib")
> > * add new allocator named SLIB (Library Allocator): Patch 04/11 is integrated
> >   to 02 (commented by Christoph Lameter)
> > - Overall
> > * rewrite commit log messages
> > 
> > changes from v1:
> > - Patch 01/11 ("sysctl: make some functions unstatic to access by arch/lib"):
> > * add prefix ctl_table_ to newly publiced functions (commented by Joe Perches)
> > - Patch 08/11 ("lib: other kernel glue layer code"):
> > * significantly reduce glue codes (stubs) (commented by Richard Weinberger)
> > - Others
> > * adapt to linux-4.0.0
> > * detect make dependency by Kbuild .cmd files
> 
> I still fail to build it. :-(
> 
> for-asm-upstream-v3 on top of Linus' tree gives:
(snip)
> arch/lib/Makefile:210: recipe for target 'arch/lib/capability.o' failed
> make: *** [arch/lib/capability.o] Error 1

I'm also aware of and already fixed this issue for pre-v4
patch of libos.

> And on top of v4.0 it fails too:
(snip)
> In file included from arch/lib/lib-socket.c:12:0:
> ./include/linux/net.h:216:5: note: declared here
>  int sock_sendmsg(struct socket *sock, struct msghdr *msg, size_t len);
>      ^
> arch/lib/Makefile:210: recipe for target 'arch/lib/lib-socket.o' failed
> make: *** [arch/lib/lib-socket.o] Error 1

since tag v4.0 to libos v3 patch, there is an update on the
sock_sendmsg(): v3 patch already followed the change. that's
why the patch can't build on top of v4.0.

> You *really* need to shape up wrt the build process.

at the moment, the implementation of libos can't automate to
follow such changes in the build process. but good news is
it's a trivial task to follow up the latest function.

my observation on this manual follow up since around 3.7
kernel (2.5 yrs ago) is that these changes mostly happened
during merge-window of each new version, and the fix only
takes a couple of hours at maximum.

I think I can survive with these changes but I'd like to ask
broader opinions.

one more question:

I'd really like to have a suggestion on which tree I should
base for libos tree.

I'm proposing a patchset to arnd/asm-generic tree (which I
believe the base tree for new arch/), while the patchset is
tested with davem/net-next tree because right now libos is
only for net/.

shall I propose a patchset based on Linus' tree instead ?

thank you for your feedback.

-- Hajime

--
To unsubscribe, send a message with 'unsubscribe linux-mm' in
the body to [email-masked].  For more info on Linux MM,
see: http://www.linux-mm.org/ .
Don't email: <a href=mailto:"[email-masked]"> [email-masked] </a>